  #include "stdinc.h"
  #include "help.inf"


/////////////////////////////////////////////////////////////////////////////
void init_256(void);                                                       //
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//                       Keyboard controller				   //
/////////////////////////////////////////////////////////////////////////////

#define KEY_UP_MASK   128
#define KEY_ALL_MASK 127
#define KEY_UP 0
#define KEY_DOWN 1
#define MAX_INPUT 200
#define BYTE unsigned char
#define NUM_SCAN_QUE 256     // this MUST be 256, using BYTE roll-over for
			     // q code

static void interrupt (far *oldkb)(...);   /* BIOS keyboard handler */


BYTE gb_scan;
BYTE gb_scan_q[NUM_SCAN_QUE];
BYTE gb_scan_head;
BYTE gb_scan_tail;

typedef struct
	{
	int sub_type;
	int data1;
	}
event_t;



event_t in[MAX_INPUT];
int i_head=0;
int i_tail=0;


/* ---------------------- get_scan() ---------------------  */
void interrupt get_scan(...)
{

   /* read the raw scan code from the keyboard */
   asm   cli

   asm   {

	 in    al, 060h       /* read scan code */
	 mov   gb_scan, al
	 in    al, 061h       /* read keyboard status */
	 mov   bl, al
	 or    al, 080h
	 out   061h, al       /* set bit 7 and write */
	 mov   al, bl
	 out   061h, al       /* write agian, bit 7 clear */

	 mov   al, 020h       /* reset PIC */
	 out   020h, al

	 /* end of re-set code */

	 sti
	 }

   *(gb_scan_q+gb_scan_tail)=gb_scan;
   ++gb_scan_tail;

}

/* ---------------------- init_keyboard() ----------------  */
void init_keyboard(void)
{
   void far *bios_key_state;

   /* save old BIOS key board handler */
   oldkb=getvect(9);

   // turn off num-lock via BIOS
   bios_key_state=MK_FP(0x040, 0x017);
   //*bios_key_state&=(~(32 | 64));     // toggle off caps lock and
				      // num lock bits in the BIOS varible
   oldkb();      // call BIOS keyhandler to change keyboard lights

   gb_scan_head=0;
   gb_scan_tail=0;
   gb_scan=0;

   /* setup our own handler */
   setvect(9, get_scan);

}

/* restore the bios keyboard handler */
/* ---------------------- deinit_keyboard() --------------  */
void deinit_keyboard(void)
{
   setvect(9, oldkb);
}



/* ---------------------- add_input() -------------------  */

void add_input(event_t *event)
{

	//in[i_tail].type=event->type;
	in[i_tail].sub_type=event->sub_type;
	in[i_tail].data1=event->data1;


	i_tail++;
	if ( i_tail == MAX_INPUT )
		i_tail=0;
   if ( i_tail == i_head )
      {
      i_head++;
      if ( i_head == MAX_INPUT )
	 i_head=0;
      }

}

/* --------------------- check_input() ------------------ */
int check_input(event_t *event)
{
	int is_event=0;
	event_t new_event;

	while ( gb_scan_head != gb_scan_tail )
		{
		new_event.data1=gb_scan_q[gb_scan_head];

		// 0xe0 indicates a key from the SECOND keypad, real code will
		// follow
		if ( new_event.data1 == 0xe0 )
			{
			gb_scan_head++;
			continue;
			}

		gb_scan_head++;

		if ( new_event.data1 & KEY_UP_MASK )
			new_event.sub_type=KEY_UP;
		else
			new_event.sub_type=KEY_DOWN;

		new_event.data1&=KEY_ALL_MASK;  // clear high bit

		// this is where you would convert the raw scan code to ascii
		// and do other high level processing if required
		// eg  new_event.data2=get_ascii(new_event.data1);

		add_input(&new_event);
		}

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// check if there are any pending events, and return the oldest one

	if ( i_head != i_tail )
		{
		is_event=1;

		//event->type=in[i_head].type;
		event->sub_type=in[i_head].sub_type;
		event->data1=in[i_head].data1;


		i_head++;
		if ( i_head == MAX_INPUT )
			i_head=0;
		}

	return is_event;
}





/////////////////////////////////////////////////////////////////////////////
//                             Display                                     //
/////////////////////////////////////////////////////////////////////////////
void init_256(void){

int d , m,errorcode;
int i;
d = installuserdriver("svga256" , NULL);
m =2;
initgraph(&d , &m , "");
errorcode = graphresult();
if (errorcode != grOk)
{
printf("Graphics error: %s\n", grapherrormsg(errorcode));
printf("Press any key to halt:");
getch();
exit(1);
}  }
/////////////////////////////////////////////////////////////////////////////
//                             Mouse                                       //
/////////////////////////////////////////////////////////////////////////////
  struct mstate
{
    int x,y;
    int buttons;
};

/////////////////////////////////////////////////////////////////////////////
  class mouse{
  public:
  struct mstate ms;
//////////////////////Proto///////////////////////////////////////////////
int  reset();
void show();
void hide();
void movetoxy(int x,int y);
void read(mstate &s);
void sethoriz(int min,int max);
void setvert(int min,int max);
void setshape(int mask[32],char x,char y);
int inarea(int x1,int y1,int x2,int y2);
void setarea(int x1,int y1,int x2,int y2);
}   ;
////////////////////////Functions//////////////////////////////////////////
   int mouse::reset()
{
_asm {
	xor ax,ax
	int 0x33
    }
    return (_AX==0xFFFF);
}
void mouse::show()
{
    _asm{
    mov ax,1
    int 0x33
    }
}
void mouse::hide()
{
    _asm{
    mov ax,2
    int 0x33
    }
}
void mouse::movetoxy(int x,int y)
{
    _asm{
    mov ax,4
    mov cx,x
    mov dx,y
    int 0x33
    }
}
void mouse::read(mstate &s)
{
    _asm{
    mov ax,3
    int 0x33
    }
    #if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
    _asm{
    push es
    push di
    les di,dword ptr s
    mov es:[di],cx // X
    mov es:[di+2],dx // Y
    mov es:[di+4],bx // button
    pop di
    pop es
    }
    #else
    _asm{
    push di
    mov di,word ptr s
    mov [di],cx
    mov [di+2],dx
    mov [di+4],bx
    pop di
    }
    #endif
}
void mouse::sethoriz(int min,int max)
{
    _asm{
    mov ax,7
    mov cx,min
    mov dx,max
    int 0x33
    }
}
void mouse::setvert(int min,int max)
{
    _asm{
    mov ax,8
    mov cx,min
    mov dx,max
    int 0x33
    }
}
void mouse::setshape(int mask[32],char x,char y)
{
    union REGS inregs,outregs;
    struct SREGS segregs;
    inregs.x.ax=0x9;
    inregs.x.bx=x;
    inregs.x.cx=y;
    inregs.x.dx=FP_OFF(mask);
    segregs.es=FP_SEG(mask);
    int86x(0x33,&inregs,&outregs,&segregs);
}
int mouse::inarea(int x1,int y1,int x2,int y2)
{
    mstate ms;
    read(ms);
    if(ms.x>=x1 && ms.x<=x2 && ms.y>=y1 && ms.y<=y2) return(1);
    else return(0);
}
void mouse::setarea(int x1,int y1,int x2,int y2)
{
    sethoriz(x1,x2);
    setvert(y1,y2);
}
/////////////////////////////////////////////////////////////////////////////
//                           Progress Bar                                  //
/////////////////////////////////////////////////////////////////////////////

  class progress_bar {
   int x,y,n,l,fc,bc,type;
   char b,f;
   public:
   void setup(int xpb,int ypb,int lpb);
   void setupadv(int bgcol,int fgcol,char bchar,char fchar,int ptype);
   void setstat(int npb);
   void display();
   };
   void progress_bar::setup(int xpb,int ypb,int lpb) {
   x=xpb;
   y=ypb;
   l=lpb;
   }
   void progress_bar::setstat(int npb) {
   n=npb;
   }
   void progress_bar::display() {
   struct text_info ti;
   gettextinfo(&ti);
   gotoxy(x,y);
   textcolor(bc);
   if(type==0){
   for(int i=0;i<l/2;i++)
   cprintf("%c ",b);
   }
   else {
   for(int i=0;i<l;i++)
   cprintf("%c",b);

   }
   gotoxy(x,y);
   textcolor(fc);
   for(int i=0;i<n;i++)
   cprintf("%c",f);
   gotoxy(ti.curx,ti.cury);
   textattr(ti.attribute);
   }
   void progress_bar::setupadv(int bgcol,int fgcol,char bchar,char fchar,int ptype) {
   bc=bgcol;
   fc=fgcol;
   b=bchar;
   f=fchar;
   type=ptype;
   }

   ////////////////////////////////////////////////////////////////////
   ////////////////////////////////////////////////////////////////////
 /*  int read();
   void mainloop();
   void main(){
   mouse m;
   clrscr();
   progress_bar pb1;
   pb1.setup(1,1,80);
   pb1.setupadv(LIGHTGRAY,BLUE,177,219,1);
   m.reset();
   m.show();

   for(int i=0;i<=80;i++) {
   pb1.setstat(i);
   pb1.display();
   delay(50);
   }

   //mainloop();
   m.hide();
   }
   ///////////////////////////////////////////////////////
   void mainloop () {


   int read() {
     if(bioskey(1)!=0){
     key=bioskey(0);
     return KEY_PRESSED;
     }
     struct mstate msys;
     m.read(msys);
     if(msys!=m.ms){
     if(msys.buttons!=m.ms.buttons){
	m.read(m.ms);
	return M_BUTTON_CH;
		  }
     m.read(m.ms);
     return M_POSITION_CH;
     }
     m.read(m.ms);
     return NOTHING;
   }                      */